#!/usr/bin/perl
#
#   ipac.cgi v1.0 By Dan Swan  -  Web frontend to ipacsum
#   Jan 4 2000.  
#
#   This is my first crack at perl cgi.  If you've any suggestions
#   as to how I could have pulled this off more securely, I am 
#   very interested in them.  E-mail me at swan_daniel@hotmail.com.  
#
#   Note:  This script outputs .asis files instead of .gifs, in order to 
#   force images to auto-refresh. See the ipacsum man page for details.
#
#   If Images do not refresh, shift-reload to force refresh.
#
#   Todo:  Incorporate full functionality of ipacsum into ipac.cgi, 
#          allow for setting of destination dir, and clean it all up.
#
#   Modifications by Todor Neshev - 18/06/2001 <sani@shells.go-link.net>
#

use POSIX qw(strftime);            
use Sys::Hostname;
use CGI qw/:standard :html3 /;

# Access
@referers = ('traffic.go-link.net');

# Checking for shits
&parse_form;

# Referers
&referers_check;

$user = $ENV{'REMOTE_USER'};
delete @ENV{qw(ENV PATH)};   # Delete $ENV variable to stop taint from choking on it.

$TRAFDIR="/var/lib/apache/htdocs/traf/traffic"; #Changing this will presently break script.
$IPADDR="traffic.go-link.net"; #Enter your hostname or IP within the brackets.  If left empty,
            # ipac.cgi will attempt to guess it.  Best left blank if your IP
            # is dynamic.
$cgi_form = new CGI; 
$forminput    = $cgi_form->param('LIST'); # Grab LIST variable from html form

system (`rm -rf /var/lib/apache/htdocs/traf/traffic/*`);  #remove old files.
# For some reason, unlink is giving a taint error, so I do it this way.  
# No time to fix to make Moritz's release date.   Will fix later.

#Validating tainted input

  if ($forminput eq "today")
     { 
       $forminput = "today";
     }  
elsif ($forminput eq "yesterday")
     {
       $forminput = "yesterday";
     }

elsif ($forminput eq "thisweek")
     {
       $forminput = "this week";
     } 
elsif ($forminput eq "lastweek")
     {
       $forminput = "last week";
     } 
elsif ($forminput eq "thismonth")
     {
       $forminput = "this month";
     }      
elsif ($forminput eq "lastmonth")
     {
       $forminput = "last month";
     }      
elsif ($forminput eq "")
     {
       $forminput = ""
     }           
  else
     {
       die ("Illegal Parameter Sent:  $forminput");  # If it aint one of the above parameters, then die.
     }

$time = strftime "%H%M%S", localtime;


if ($IPADDR eq "")  # Has user declared own hostname?
   { 
   $IPADDR = hostname();  
   }

if (! -d $TRAFDIR)  #Does traffic Directory not exist?
   {
   mkdir ($TRAFDIR,0755);
   }

if ( $user eq "admin")
	{
	$user = "all";
	}

system("/usr/local/sbin/ipacsum -filter \"$user\" -timeframe \"$forminput\"  --gif \"$TRAFDIR\" --gif-index /var/lib/apache/htdocs/traf/traffic/index${time}.html --gif-caption-in-index  --gif-asis 2>&1 > /dev/null ");

print "Location: http://traffic.go-link.net/traffic/index${time}.html", "\n\n";

exit (0);   # What the heck.


sub parse_form {

# Configiration array
        %Config = ('LIST','','REMOTE_USER','');

         if ($ENV{'REQUEST_METHOD'} eq 'GET') {
                @pairs = split(/&/, $ENV{'QUERY_STRING'});
        }
         elsif ($ENV{'REQUEST_METHOD'} eq 'POST') {

                read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
                @pairs = split(/&/, $buffer);
        }
         else {
                &error('request_method');
                }

         foreach $pair (@pairs) {
                local($name, $value) = split(/=/, $pair);

                $name =~ tr/+/ /;
                $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", 
hex($1))/eg;

                $value =~ tr/+/ /;
                $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", 
hex($1))/eg;

                $value =~ s/<!--(.|\n)*-->//g;

         if (defined($Config{$name})) {
                $Config{$name} = $value;
        }
         else {
                 if ($Form{$name} && $value) {
                        $Form{$name} = "$Form{$name}, $value";
                }
         elsif ($value) {
                push(@Field_Order,$name);
                $Form{$name} = $value;
                        }
       }
    }
}

sub referers_check {

         if ($ENV{'HTTP_REFERER'}) {
                foreach $referer (@referers) {
                 if ($ENV{'HTTP_REFERER'} =~ m|https?://([^/]*)$referer|i) 
{
                        $check_referer = 1;
                 last;
                }
        }
    }
         else {
                $check_referer = 1;
        }

# If the HTTP_REFERER was invalid, send back an error.
         if ($check_referer != 1) {
&html_head;
print "<br><br><br><br><center>Access Denied because of inccorect IP 
address !!!</center>";
&html_foot;
exit;
        }
                }

sub html_head {
                print "Content-type: text/html\n\n";
}
